-- noBrainShiftConfig.lua



local function buildIngameConfig()

	local titel = CreateFrame("Frame","ConfigTitle", UIParent)
		--titel:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Header", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		titel:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Header",tile = false });
		titel:SetBackdropColor(1,1,1)
		titel:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 300, -50)
		titel:SetSize(256,64)
		
		titel:SetMovable(true)
		
		titel:SetScript("OnMouseDown", function(self) titel:StartMoving() end )
		titel:SetScript("OnMouseUp", function(self) titel:StopMovingOrSizing() end )
	
		titel:Hide();
		
	local textbox = MoonTime:CreateFontString(titel, "textbox", "ARTWORK", "GameFontNormal", "TOP", titel, "TOP", 0, -4, 128, 32, "CENTER", "MIDDLE",  1, 1, 1, 1 );
		textbox:SetText("|cffFFD200"..L["Config_Moverframe"].."|r")
		textbox:Show()	
	
	local aussen = CreateFrame("Frame","Aussenframe", titel)
		aussen:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 32, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
		aussen:SetBackdropColor(0,0,0)
		aussen:SetPoint("TOP", titel, "TOP", 0, -16)
		aussen:SetFrameLevel(titel:GetFrameLevel()-1);
		aussen:SetSize(275,500)
		aussen:Show();
		
local skills = {
	["MoonTimeNextCastframe"] = {["appearance"] = {}, ["icon"] = SS_icon, ["selected"] = true},
	["MoonTimeEclipseframe"] = {["appearance"] = {"text","no text"}, ["icon"] = Lunar_icon, ["selected"] = true},
	["MoonTimeMFframe"] = {["appearance"] = {"popup","text"}, ["icon"] = MF_icon, ["selected"] = true},
	["MoonTimeSunFframe"] = {["appearance"] = {"popup","text"}, ["icon"] = SunF_icon, ["selected"] = true},
	["MoonTimeStarrainframe"] = {["appearance"] = {"popup","text"}, ["icon"] = SR_icon, ["selected"] = true},
	["MoonTimeFaerieFireframe"] = {["appearance"] = {"popup","text"}, ["icon"] = FF_icon, ["selected"] = true},
	["MoonTimeCelestialAlignmentframe"] = {["appearance"] = {"popup","text"}, ["icon"] = CA_icon, ["selected"] = true},
	}		

 local liste = {
	"MoonTimeNextCastframe",
	"MoonTimeEclipseframe",
	"MoonTimeMFframe",
	"MoonTimeSunFframe",
	"MoonTimeStarrainframe",
	"MoonTimeFaerieFireframe",
	"MoonTimeCelestialAlignmentframe"
	}	

 for a = 1, 18, 1 do

	local name, texture, _, _, selected = GetTalentInfo(a)
	tinsert (liste, name)
	
	skills[name] = {["appearance"] = {"popup","text"}, ["icon"] = texture, ["name"] = name, ["selected"] = selected}
	L[name] = name;
end		

local layoutanker = MoonTime:CreateFrame( "Frame", "layoutanker", aussen, "", "CENTER", UIParent, "CENTER", 0, 0, 100, 100)
	layoutanker:SetPoint(MoonTime_DB["position"]["point"], UIPARRENT, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"])
		
v = 0;
	local time = GetTime()
		
		for index, value in pairs(liste) do

	
	

local anker = MoonTime:CreateFrame( "Frame", "anker", aussen, "", "TOPLEFT", aussen, "TOPLEFT", 20, -32-v*50, 281, 40)
	anker:Show()
	skills[value]["frame"] = anker

local pictureframe = MoonTime:CreateFrame( "Frame", "PictureFrame", anker, "", "TOPLEFT", anker, "TOPLEFT", 0, 0, 32, 32)
		pictureframe:SetBackdrop({
			bgFile = skills[value]["icon"],
			tile = false, tileSize = height, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})
		
local layoutframe = MoonTime:CreateFrame( "Frame", "PictureFrame", anker, "", "CENTER", layoutanker, "CENTER", MoonTime_DB["Layout_noBrainShift"][value]["xoffset"], MoonTime_DB["Layout_noBrainShift"][value]["yoffset"], MoonTime_DB["Layout_noBrainShift"][value]["xdim"], MoonTime_DB["Layout_noBrainShift"][value]["ydim"])
		layoutframe:SetBackdrop({
			bgFile = skills[value]["icon"],
			tile = false, tileSize = height, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})

local setlayoutframe = function()
	layoutframe:ClearAllPoints()
	layoutframe:SetPoint("CENTER", layoutanker, "CENTER", MoonTime_DB["Layout_noBrainShift"][value]["xoffset"], MoonTime_DB["Layout_noBrainShift"][value]["yoffset"])
	layoutframe:SetHeight(MoonTime_DB["Layout_noBrainShift"][value]["ydim"])
	layoutframe:SetWidth(MoonTime_DB["Layout_noBrainShift"][value]["xdim"])
end
		
	
local textbox1 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton1, "TOPRIGHT", 10, -2, 270, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox1:SetText(L[value])
	textbox1:Show()	

local textbox2 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormalSmall", "TOPLEFT", pictureframe, "TOPRIGHT", 0, 0, 50, 16, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox2:SetText("x offset")
	textbox2:SetJustifyH("RIGHT");
	textbox2:Show()

local editframe1 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox1_"..value..time, anker, "InputBoxTemplate", "LEFT", textbox2, "RIGHT", 10, 0, 40, 12)
	editframe1:SetAutoFocus(false) 
	editframe1:SetText(MoonTime_DB["Layout_noBrainShift"][value]["xoffset"]);
	editframe1:SetJustifyH("CENTER");
	editframe1:SetJustifyV("CENTER");
	editframe1:SetCursorPosition(0)
	editframe1:Show()
	editframe1:SetScript("OnTextChanged", function(self) MoonTime_DB["Layout_noBrainShift"][value]["xoffset"] = editframe1:GetNumber() setlayoutframe() end )
	
local textbox3 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormalSmall", "TOPLEFT", textbox2, "BOTTOMLEFT", 0, 0, 50, 16, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox3:SetText("y offset")
	textbox3:SetJustifyH("RIGHT");
	textbox3:Show()

local editframe2 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox2_"..value..time, anker, "InputBoxTemplate", "LEFT", textbox3, "RIGHT", 10, 0, 40, 12)
	editframe2:SetAutoFocus(false) 
	editframe2:SetText(MoonTime_DB["Layout_noBrainShift"][value]["yoffset"]);
	editframe2:SetJustifyH("CENTER");
	editframe2:SetJustifyV("CENTER");
	editframe2:SetCursorPosition(0)
	editframe2:SetScript("OnTextChanged", function(self) MoonTime_DB["Layout_noBrainShift"][value]["yoffset"] = editframe2:GetNumber() setlayoutframe()  end )
	editframe2:Show()

	
local textbox4 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormalSmall", "TOPLEFT", textbox2, "TOPRIGHT", 50, 0, 50, 12, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox4:SetText("x dim")
	textbox4:SetJustifyH("RIGHT");
	textbox4:Show()

local editframe3 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox3_"..value..time, anker, "InputBoxTemplate", "LEFT", textbox4, "RIGHT", 10, 0, 40, 12)
	editframe3:SetAutoFocus(false) 
	editframe3:SetText(MoonTime_DB["Layout_noBrainShift"][value]["xdim"]);
	editframe3:SetJustifyH("CENTER");
	editframe3:SetJustifyV("CENTER");
	editframe3:SetCursorPosition(0)
	editframe3:SetScript("OnTextChanged", function(self) MoonTime_DB["Layout_noBrainShift"][value]["xdim"] = editframe3:GetNumber() setlayoutframe() end )
	editframe3:Show()
	

local textbox5 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormalSmall", "TOPLEFT", textbox3, "TOPRIGHT", 50, 0, 50, 12, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox5:SetText("y dim")
	textbox5:SetJustifyH("RIGHT");
	textbox5:Show()

local editframe4 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox4_"..value..time, anker, "InputBoxTemplate", "LEFT", textbox5, "RIGHT", 10, 0, 40, 12)
	editframe4:SetAutoFocus(false) 
	editframe4:SetText(MoonTime_DB["Layout_noBrainShift"][value]["ydim"]);
	editframe4:SetJustifyH("CENTER");
	editframe4:SetJustifyV("CENTER");
	editframe4:SetCursorPosition(0)
	editframe4:SetScript("OnTextChanged", function(self) MoonTime_DB["Layout_noBrainShift"][value]["ydim"] = editframe4:GetNumber() setlayoutframe() end )
	editframe4:Show()



anker:Hide()

	
end

titel.OnShow = function()
	for a = 1, 18, 1 do

		local name, texture, _, _, selected = GetTalentInfo(a)
			
		skills[name]["selected"] = selected
	end	


	v = 0;

	for index, value in pairs(liste) do
		skills[value]["frame"]:Hide()
		
		if MoonTime_DB["Layout_noBrainShift"][value]["active"] and skills[value]["selected"] then
	
			skills[value]["frame"]:SetPoint("TOPLEFT", aussen, "TOPLEFT", 20, -32-v*50, 281, 40)
			skills[value]["frame"]:Show()
			
			v = v+1;
		end
	end
	aussen:SetSize(275,32+v*50+30)	
	titel:Show()
end


	
local button = CreateFrame("BUTTON", "Button", aussen, "UIPanelButtonTemplate")
	button:SetText(L["Config_Moverframe_done"])
	button:SetWidth(100)
	button:SetHeight(25)
	button:SetScript("OnClick", function(self) MoonTime:ToggleConfig()  titel:Hide() InterfaceOptionsFrame_OpenToCategory("noBrainShift") MoonTime:setLayout(MoonTime_DB["layout"]) end)
	button:SetPoint('BOTTOM', aussen, 'BOTTOM', 0, 15)	
		
	aussen:SetSize(275,32+v*50+30)	

	return titel
end






-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-- %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%










local function noBrainShiftBuildConfig(MoonTimeConfigPanel)




if ( GetLocale() == "deDE" ) then
	L = MoonTime_noBrainShift_Strings["deDE"]
else
	L = MoonTime_noBrainShift_Strings["enGB"]
end

-- Make a child panel
local MoonTime_Layout_noBrainShift_ConfigPanel = CreateFrame( "ScrollFrame", "MyAddonChild", MoonTimeConfigPanel);
MoonTime_Layout_noBrainShift_ConfigPanel:SetBackdropColor(1,0,1,1)
MoonTime_Layout_noBrainShift_ConfigPanel:SetWidth(200)
 MoonTime_Layout_noBrainShift_ConfigPanel:SetHeight(200)
  --MoonTime_Layout_noBrainShift_ConfigPanel:SetOrientation('VERTICAL')


MoonTime_Layout_noBrainShift_ConfigPanel.name = "noBrainShift";
 -- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
 MoonTime_Layout_noBrainShift_ConfigPanel.parent = MoonTimeConfigPanel.name;
 

 -- Add the child to the Interface Options
 InterfaceOptions_AddCategory(MoonTime_Layout_noBrainShift_ConfigPanel);
 
 
local movepanel = buildIngameConfig()	;



 
local skills = {
	["MoonTimeNextCastframe"] = {["appearance"] = {}, ["icon"] = SS_icon},
	["MoonTimeEclipseframe"] = {["appearance"] = {"text","no text"}, ["icon"] = Lunar_icon},
	["MoonTimeMFframe"] = {["appearance"] = {"popup","text"}, ["icon"] = MF_icon},
	["MoonTimeSunFframe"] = {["appearance"] = {"popup","text"}, ["icon"] = SunF_icon},
	["MoonTimeStarrainframe"] = {["appearance"] = {"popup","text"}, ["icon"] = SR_icon},
	["MoonTimeFaerieFireframe"] = {["appearance"] = {"popup","text"}, ["icon"] = FF_icon},
	["MoonTimeCelestialAlignmentframe"] = {["appearance"] = {"popup","text"}, ["icon"] = CA_icon},
	}
 
 
 local liste = {
	"MoonTimeNextCastframe",
	"MoonTimeEclipseframe",
	"MoonTimeMFframe",
	"MoonTimeSunFframe",
	"MoonTimeStarrainframe",
	"MoonTimeFaerieFireframe",
	"MoonTimeCelestialAlignmentframe"
	}
 
 for a = 1, 18, 1 do

	local name, texture = GetTalentInfo(a, 1, nil, nil, 11)
	tinsert (liste, name)
	
	skills[name] = {["appearance"] = {"popup","text"}, ["icon"] = texture, ["name"] = name}
	L[name] = name;
end
 

 
local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrainShift_ConfigPanel, "textbox", "ARTWORK", "GameFontNormalLarge", "TOPLEFT", MoonTime_Layout_noBrainShift_ConfigPanel, "TOPLEFT", 10, -10, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText("|cffFFFF00".."Layout noBrainShift".."|r")
	textbox:Show()	
local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrainShift_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "TOPLEFT", textbox, "BOTTOMLEFT", 0, 0, 500, 100, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["description"])
	textbox:SetHeight(textbox:GetStringHeight())
	textbox:Show()	
	

	
local button = CreateFrame("BUTTON", "Button", MoonTime_Layout_noBrainShift_ConfigPanel, "UIPanelButtonTemplate")
	button:SetText(L["OpenMoverframe"])
	button:SetWidth(140)
	button:SetHeight(25)
	button:SetScript("OnClick", function(self) 
		MoonTime:ToggleConfig() 
		InterfaceOptionsFrame:Hide() 
		movepanel:OnShow()
	end)
	button:SetPoint('TOPLEFT', textbox, 'BOTTOMLEFT', 0, -5)	 
	
	
	
	
local aussen = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrainShift_ConfigPanel)
	aussen:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	aussen:SetBackdropColor(0,0,0)
	aussen:SetPoint("TOPLEFT", textbox, "BOTTOMLEFT", 0, -40)
	aussen:SetSize(574,465)
	aussen:Show();
	
local scroller = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrainShift_ConfigPanel)
	scroller:SetBackdrop({bgFile = "Interface/TutorialFrame/TutorialFrameBackground", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	scroller:SetBackdropColor(0,0,0.2)
	scroller:SetPoint("TOPLEFT", aussen, "TOPRIGHT", 0, 0)
	scroller:SetSize(27,27)
	scroller:Show();
	
local scroller = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrainShift_ConfigPanel)
	scroller:SetBackdrop({bgFile = "Interface/TutorialFrame/TutorialFrameBackground", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	scroller:SetBackdropColor(0,0,0.2)
	scroller:SetPoint("TOPLEFT", aussen, "TOPRIGHT", 0, -27+12)
	scroller:SetSize(27,430)
	scroller:Show();
	
local scroller = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrainShift_ConfigPanel)
	scroller:SetBackdrop({bgFile = "Interface/TutorialFrame/TutorialFrameBackground", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	scroller:SetBackdropColor(0,0,0.2)
	scroller:SetPoint("TOPLEFT", aussen, "TOPRIGHT", 0, -437)
	scroller:SetSize(27,27)
	scroller:Show();

local MoonTime_Layout_noBrainShift_ScrollFrame = CreateFrame("ScrollFrame", "MoonTime_Layout_noBrainShift_ScrollFramereviewFrame", MoonTime_Layout_noBrainShift_ConfigPanel, "UIPanelScrollFrameTemplate")
	MoonTime_Layout_noBrainShift_ScrollFrame:SetPoint("TOPLEFT", aussen, "TOPLEFT", 6, -6)
	MoonTime_Layout_noBrainShift_ScrollFrame.name = "Scrollframe";
 
local MoonTime_Layout_noBrainShift_ScrollFrameScrollChild = CreateFrame("Frame", "MoonTime_Layout_noBrainShift_ScrollFramereviewSC", MoonTime_Layout_noBrainShift_ScrollFrame)
 
 
local PADDING = 5
local height = 465-12
local width = 562
 

local labelframe = CreateFrame("Frame","labelframe", MoonTime_Layout_noBrainShift_ScrollFrame)
	labelframe:SetPoint("TOPLEFT", MoonTime_Layout_noBrainShift_ScrollFrame, "TOPLEFT", 0, 0)
	labelframe:SetWidth(width)
	labelframe:SetHeight(44*16*5)
	
v = 0;
a = 0;
	
for index, value in pairs(liste) do



if ceil(v/2) == v/2 then 
	a = 0;
	else
	a = 281;
end	
	
local anker = MoonTime:CreateFrame( "Frame", "anker", labelframe, "", "TOPLEFT", labelframe, "TOPLEFT", 2+a, -2-floor(v/2)*100, 281, 40)
	anker:Hide()
	skills[value]["frame"] = anker
	

	

local checkbutton1 = MoonTime:CreateFrame("CheckButton", "CheckButton1_"..value, anker, "UICheckButtonTemplate", "TOPLEFT", anker, "TOPLEFT", 0, 0, 28, 28)

	if MoonTime_DB["Layout_noBrainShift"][value]["active"] then checkbutton1:SetChecked() end
	checkbutton1:Show()

local textbox1 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormal", "TOPLEFT", checkbutton1, "TOPRIGHT", 0, -2, 270, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox1:SetText(L[value])
	textbox1:Show()		
	
local pictureframe = MoonTime:CreateFrame( "Frame", "PictureFrame", anker, "", "TOPLEFT", checkbutton1, "BOTTOMLEFT", 3, 0, 48, 48)
		pictureframe:SetBackdrop({
			bgFile = skills[value]["icon"],
			tile = false, tileSize = height, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})

if value == "MoonTimeNextCastframe" then
	local checkbutton3 = MoonTime:CreateFrame("CheckButton", "CheckButton3_"..value, anker, "UICheckButtonTemplate", "TOPLEFT", pictureframe, "TOPRIGHT", 10, 0, 28, 28)
		if MoonTime_DB["Layout_noBrainShift"][value]["noBrainTile_EclipsePower"] then checkbutton3:SetChecked() end
		checkbutton3:SetScript("OnClick", function(self) 
			if checkbutton3:GetChecked() then
				MoonTime_DB["Layout_noBrainShift"][value]["noBrainTile_EclipsePower"] = true
			else
				MoonTime_DB["Layout_noBrainShift"][value]["noBrainTile_EclipsePower"] = false
			end 
			MoonTime:setLayout(MoonTime_DB["layout"])
		end)
		checkbutton3:Show()
	
	local textbox3 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormal", "LEFT", checkbutton3, "RIGHT", 0, 0, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
		textbox3:SetText(L["noBrainTile_EclipsePower"])
		textbox3:SetJustifyV("MIDDLE");
		textbox3:Show()	
end	
		
local checkbutton2 = MoonTime:CreateFrame("CheckButton", "CheckButton2_"..value, anker, "UICheckButtonTemplate", "TOPLEFT", pictureframe, "TOPRIGHT", 10, -25, 28, 28)
	if MoonTime_DB["Layout_noBrainShift"][value]["glow"] then checkbutton2:SetChecked() end
	checkbutton2:SetScript("OnClick", function(self) 
		if checkbutton2:GetChecked() then
			MoonTime_DB["Layout_noBrainShift"][value]["glow"] = true
		else
			MoonTime_DB["Layout_noBrainShift"][value]["glow"] = false
		end 
		MoonTime:setLayout(MoonTime_DB["layout"])
	end)
	checkbutton2:Show()

	
local textbox2 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormal", "LEFT", checkbutton2, "RIGHT", 0, 0, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox2:SetText(L["Glow_Tile"])
	if value == "MoonTimeNextCastframe" or value == "MoonTimeEclipseframe" then textbox2:SetText(L["Glow_noBrainTile"]) end
	textbox2:SetJustifyV("MIDDLE");
	textbox2:Show()	
		
--[[
local textbox2 = MoonTime:CreateFontString(anker, "textbox", "ARTWORK","GameFontNormalSmall", "TOPLEFT", pictureframe, "TOPRIGHT", 0, 0, 50, 16, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox2:SetText("x offset")
	textbox2:SetJustifyH("RIGHT");
	textbox2:Show()


local editframe1 = MoonTime:CreateFrame("EditBox", "MoonTimeEditBox1_"..value, anker, "InputBoxTemplate", "LEFT", textbox2, "RIGHT", 10, 0, 40, 12)
	editframe1:SetAutoFocus(false) 
	editframe1:SetText(MoonTime_DB["Layout_noBrainShift"][value]["xoffset"]);
	editframe1:SetJustifyH("CENTER");
	editframe1:SetJustifyV("CENTER");
	editframe1:SetCursorPosition(0)
	--editframe1:SetScript("OnTextChanged", function(self) MoonTime_DB["Layout_noBrainShift"][value]["xoffset"] = editframe1:GetNumber() MoonTime:setLayout(MoonTime_DB["layout"]) end )
	editframe1:Show()
	
--]]	

if getn(skills[value]["appearance"])>0 then 	


	
local function initialize(self, level)
	local info = UIDropDownMenu_CreateInfo()
   
	for i, v in pairs(skills[value]["appearance"]) do
		info = UIDropDownMenu_CreateInfo()
		info.text = L["Dropdown_"..v]
		
		info.value = v
		info.func = function(self) 
			UIDropDownMenu_SetSelectedID( UIDROPDOWNMENU_OPEN_MENU, self:GetID()) 
			UIDropDownMenu_SetSelectedValue( UIDROPDOWNMENU_OPEN_MENU , v) --self:GetText()) 
			MoonTime_DB["Layout_noBrainShift"][value]["appearance"] = v --self:GetText();
			MoonTime:setLayout(MoonTime_DB["layout"])
		end
		UIDropDownMenu_AddButton(info, level)
	end
end


local MoonTimeLayoutsDropDown=CreateFrame("Frame", "MoonTimeLayoutsDropDown_"..value, anker, "UIDropDownMenuTemplate")
	MoonTimeLayoutsDropDown:ClearAllPoints()
	MoonTimeLayoutsDropDown:SetPoint('TOPLEFT', pictureframe, 'TOPRIGHT', -5, 2)
	MoonTimeLayoutsDropDown:Show()
--	MoonTimeLayoutsDropDown:SetScript("OnShow", function(self)
 
 UIDropDownMenu_Initialize(MoonTimeLayoutsDropDown, initialize, "")
 UIDropDownMenu_SetWidth(MoonTimeLayoutsDropDown, 170);
 UIDropDownMenu_SetButtonWidth(MoonTimeLayoutsDropDown, 254)
 UIDropDownMenu_SetSelectedValue(MoonTimeLayoutsDropDown, MoonTime_DB["Layout_noBrainShift"][value]["appearance"])
 UIDropDownMenu_JustifyText(MoonTimeLayoutsDropDown, "LEFT")
 
 --MoonTimeLayoutsDropDown:SetPoint('LEFT', textbox1, 'LEFT', 0, -100)
 --end)


end


		if ( checkbutton1:GetChecked() ) then 
			textbox1:SetTextColor(1,1,1)
			textbox2:SetTextColor(1,1,1)
			pictureframe:SetBackdropColor(1,1,1)
		else 
			textbox1:SetTextColor(0.5,0.5,0.5)
			textbox2:SetTextColor(0.5,0.5,0.5)
			pictureframe:SetBackdropColor(.5,.5,.5)
		end 	

 --[[
		if ( checkbutton1:GetChecked() ) then 
			textbox1:SetTextColor(1,1,1) textbox2:SetTextColor(1,1,1) textbox3:SetTextColor(1,1,1) textbox4:SetTextColor(1,1,1) textbox5:SetTextColor(1,1,1) 
			editframe1:SetTextColor(1,1,1) editframe2:SetTextColor(1,1,1) editframe3:SetTextColor(1,1,1) editframe4:SetTextColor(1,1,1)
		else 
			textbox1:SetTextColor(0.5,0.5,0.5) textbox2:SetTextColor(0.5,0.5,0.5) textbox3:SetTextColor(0.5,0.5,0.5) textbox4:SetTextColor(0.5,0.5,0.5) textbox5:SetTextColor(0.5,0.5,0.5) 
			editframe1:SetTextColor(0.5,0.5,0.5) editframe2:SetTextColor(0.5,0.5,0.5) editframe3:SetTextColor(0.5,0.5,0.5) editframe4:SetTextColor(0.5,0.5,0.5)
		end 	
--]]
	
	checkbutton1:SetScript("OnClick", function(self) 
		if ( checkbutton1:GetChecked() ) then 
			textbox1:SetTextColor(1,1,1)
			MoonTime_DB["Layout_noBrainShift"][value]["active"] = true
			textbox2:SetTextColor(1,1,1)
			pictureframe:SetBackdropColor(1,1,1)
		else 
			textbox1:SetTextColor(0.5,0.5,0.5)
			MoonTime_DB["Layout_noBrainShift"][value]["active"] = false
			textbox2:SetTextColor(0.5,0.5,0.5)
			pictureframe:SetBackdropColor(.5,.5,.5)
		end 
--[[		if ( checkbutton1:GetChecked() ) then 
			textbox1:SetTextColor(1,1,1) textbox2:SetTextColor(1,1,1) textbox3:SetTextColor(1,1,1) textbox4:SetTextColor(1,1,1) textbox5:SetTextColor(1,1,1) 
			editframe1:SetTextColor(1,1,1) editframe2:SetTextColor(1,1,1) editframe3:SetTextColor(1,1,1) editframe4:SetTextColor(1,1,1)
		else 
			textbox1:SetTextColor(0.5,0.5,0.5) textbox2:SetTextColor(0.5,0.5,0.5) textbox3:SetTextColor(0.5,0.5,0.5) textbox4:SetTextColor(0.5,0.5,0.5) textbox5:SetTextColor(0.5,0.5,0.5) 
			editframe1:SetTextColor(0.5,0.5,0.5) editframe2:SetTextColor(0.5,0.5,0.5) editframe3:SetTextColor(0.5,0.5,0.5) editframe4:SetTextColor(0.5,0.5,0.5)
		end 
		if checkbutton1:GetChecked() then
			MoonTime_DB["Layout_noBrainShift"][value]["active"] = true
		else
			MoonTime_DB["Layout_noBrainShift"][value]["active"] = false
		end --]]
		MoonTime:setLayout(MoonTime_DB["layout"])

	end)

	if ( not MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["active"] ) then 
		textbox1:SetTextColor(0.5,0.5,0.5) textbox2:SetTextColor(0.5,0.5,0.5) textbox3:SetTextColor(0.5,0.5,0.5) textbox4:SetTextColor(0.5,0.5,0.5) textbox5:SetTextColor(0.5,0.5,0.5) 
		editframe1:SetTextColor(0.5,0.5,0.5) editframe2:SetTextColor(0.5,0.5,0.5) editframe3:SetTextColor(0.5,0.5,0.5) editframe4:SetTextColor(0.5,0.5,0.5)
	end

	
	
	v = v+1;
end
		


local function truefalseGetChecked(button)
	if ( button:GetChecked() ) then
		return true
	else
		return false
	end
end
	

	
local function buildOnShow()
for v=0,6,1 do
	if ceil(v/2) == v/2 then 
		a = 0;
	else
		a = 281;
	end
	
	skills[liste[v+1]]["frame"]:SetPoint("TOPLEFT", labelframe, "TOPLEFT", 2+a, -2-floor(v/2)*100)
	skills[liste[v+1]]["frame"]:Show()
end


for v=7,getn(liste)-1,1 do
	skills[liste[v+1]]["frame"]:Hide()
end
t=7;
for v = 1, 6, 1 do
	local isFree, talent = GetTalentRowSelectionInfo(v)
	local continue = false;
	local name, texture, tier, column, selected, available = GetTalentInfo(talent, 1, nil, nil, 11)

	if talent == 1 or talent == 7  or talent == 10  or talent == 17 then  continue = true  end

	if not continue then


		if ceil(t/2) == t/2 then 
			a = 0;
		else
			a = 281;
		end

		skills[name]["frame"]:SetPoint("TOPLEFT", labelframe, "TOPLEFT", a, 0-floor(t/2)*100)
		skills[name]["frame"]:Show()
		t=t+1;
	end
labelframe:SetHeight((floor(t/2))*100)
end


	
end

MoonTime_Layout_noBrainShift_ConfigPanel:SetScript("OnShow",
	function(self)
			buildOnShow()

	end
)	

	
	-- Set the size of the scroll child
MoonTime_Layout_noBrainShift_ScrollFrameScrollChild:SetSize(width, height)
 
-- Size and place the parent frame, and set the scrollchild to be the
-- frame of font strings we've created
MoonTime_Layout_noBrainShift_ScrollFrame:SetSize(width+6, height)
MoonTime_Layout_noBrainShift_ScrollFrame:SetScrollChild(labelframe)

MoonTime_Layout_noBrainShift_ConfigPanel:Hide()


--InterfaceOptionsFrame_OpenToCategory("noBrainShift")
return MoonTime_Layout_noBrainShift_ConfigPanel

end


-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerConfig( )									-- Beginn initialize
	local configFrame
	local frame = CreateFrame( "Frame", "frame", UIPARENT	)
	frame:RegisterEvent("VARIABLES_LOADED");
	--frame:RegisterEvent("PLAYER_TALENT_UPDATE");

	--local kannlosgehen = false



				
				
	frame:SetScript("OnEvent", 
		function( self, event )
		
			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
																		
																		
				
				
				frame:SetScript("OnUpdate", function(self, event, ... ) 		
					name = GetTalentInfo(18, 1, nil, nil, 11);
		
				if name then
					frame:SetScript("OnUpdate",nil)
					frame:UpdateDB()
					MoonTimeDoorKeeper:RegisterConfig( self );
					
					
					-- Fix the "can't open on the first time" bug
					InterfaceOptionsFrame_OpenToCategory("MoonTime")
					InterfaceOptionsFrame:Hide()
					
						titel = buildIngameConfig();
				end 
		
			end)
		end
	end)



	
	frame.UpdateDB = function()
		--MoonTime_DB["Layout_noBrainShift"]

		local defaultDB = {
			["MoonTimeNextCastframe"] = {
				["active"] = true,
				["xoffset"] = 0,
				["yoffset"] = -24,
				["xdim"] = 48,
				["ydim"] = 48,
			},
			["MoonTimeEclipseframe"] = {
				["active"] = true,
				["appearance"] = "text",
				["xoffset"] = 36,
				["yoffset"] = -36,
				["xdim"] = 24,
				["ydim"] = 24,
			},
			["MoonTimeMFframe"] = {
				["active"] = true,
				["appearance"] = "text",
				["xoffset"] = -36,
				["yoffset"] = -12,
				["xdim"] = 24,
				["ydim"] = 24,
			},
			["MoonTimeSunFframe"] = {
				["active"] = true,
				["appearance"] = "text",
				["xoffset"] = -36,
				["yoffset"] = -36,
				["xdim"] = 24,
				["ydim"] = 24,
			},
			["MoonTimeStarrainframe"] = {
				["active"] = false,
				["appearance"] = "text",
				["xoffset"] = -9,
				["yoffset"] = -45,
				["xdim"] = 24,
				["ydim"] = 24,
			},
			["MoonTimeFaerieFireframe"] = {
				["active"] = false,
				["appearance"] = "text",
				["xoffset"] = 27,
				["yoffset"] = -9,
				["xdim"] = 24,
				["ydim"] = 24,
			},
			["MoonTimeCelestialAlignmentframe"] = {
				["active"] = false,
				["appearance"] = "text",
				["xoffset"] = -24,
				["yoffset"] = -200,
				["xdim"] = 48,
				["ydim"] = 48,
			},
		}

		for a = 1, 18, 1 do
		local name, texture = GetTalentInfo(a, 1, nil, nil, 11)
--		MoonTime:echo(name)
--		if MoonTime_DB["Layout_noBrainShift"][name] == nil then
			--MoonTime_DB["Layout_noBrainShift"][name] = {
			defaultDB[name] = {
				["active"] = false,
				["appearance"] = "text",
				["xoffset"] = 20,
				["yoffset"] = 96-48*floor((a-1)/3),
				["xdim"] = 48,
				["ydim"] = 48,	
			}
		--end
		end
	
	if not MoonTime_DB["Layout_noBrainShift"] then
		MoonTime_DB["Layout_noBrainShift"] = {}
	end
	
	for value in pairs(defaultDB) do
		for stat in pairs(defaultDB[value]) do
			if not MoonTime_DB["Layout_noBrainShift"][value] then
				MoonTime_DB["Layout_noBrainShift"][value] = {}
			end
		
			if MoonTime_DB["Layout_noBrainShift"][value][stat] == nil then
				MoonTime_DB["Layout_noBrainShift"][value][stat] = defaultDB[value][stat]
			end
		end
	end
	
	
	end
	
	frame.createConfig = function( MainConfigFrame )
		configFrame = noBrainShiftBuildConfig( MainConfigFrame )
	end
end																		-- Ende initialize

registerConfig(NameOfLayout)

