-- MejLayout.lua
local NameOfLayout = "noBrainShift"
local Description
local layerFrame

local debugging = false

local function Layout(mainFrame, cds)

	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()

	--RunScript(MoonTime_DB["Layout_noBrain"]["boxtext"])
	RunScript(MoonTime_DB["Layout_noBrain"][MoonTime_DB["Layout_noBrain"]["rotation"]])
	
	
	
	
	local time_newicon = GetTime();
	local oldcast = mynext(cds);
	local newcast;
	local dim;
	
	local SR_CD
	local isLunar
	local isSolar
	local eclipseDirection
	local eclipsePower
	local MF_CD
	local SunF_CD
	local IS_CD
	local FF_CD

	local MoonTimeNextCastframe
	local MoonTimeEclipseframe
	local MoonTimeMFframe
	local MoonTimeSunFframe
	local MoonTimeStarrainframe
	local MoonTimeFaerieFireframe

	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	

local TierListe = {}




layerFrame.Update = function()
	SR_CD = cds:GetStarfallCD()
	Treants_CD = cds:GetTreantsCD()
	isLunar = cds:isLunar()
	isSolar = cds:isSolar()
	eclipseDirection, eclipsePower = cds:GetEclipseDirection()
	MF_CD = cds:GetMoonfireCD()
	SunF_CD = cds:GetSunfireCD()
	IS_CD = cds:GetInsectSwarmCD()
	FF_CD = cds:GetFaerieFireCD()
	CA_CD = cds:GetCelestialAlignmentCD()
	
local procs = 0;

local proclist = {
	137590, -- Metagem
	146046, -- Bindings of Immerseus
	148906, -- Toxic Totem Kardis
	}
	
for a=1,40 do

	local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player",a,"PLAYER")
	

	
	for index, value in pairs(proclist) do
		if spellId == value then
			procs=procs+1;
		end
	end
end

-- bugfix, why the hell?	
--mainFrame:SetScale(UIParent:GetScale())



	-- MoonTimeNextCastframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["active"] ) then 
	MoonTimeNextCastframe:Show()
	newcast = mynext(cds)
	
	if oldcast ~= newcast then
		time_newicon = GetTime();
	end
	oldcast = newcast

	xdim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"];
	ydim = MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"];
	MoonTimeNextCastframe:SetIcon(newcast)
	if MoonTime_DB["Layout_noBrain"]["blinkspells"][newcast] then
	--GetTime-time_newicon -- wenn 0 volle gre
						--	wenn time_descale normale gre
		xdim = max(MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]*MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5),MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"]);
		ydim = max(MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"]*MoonTime_DB["Layout_noBrain"]["blink_factor"]*(1-((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5),MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"]);
		alpha = min( 0.75+((GetTime()-time_newicon)/MoonTime_DB["Layout_noBrain"]["blink_time_descale"])^5/2 , 1 )
	end
	
	--if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["appearance"] == "text" ) then
	--eclipsePower
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["noBrainTile_EclipsePower"] then
		if ( eclipseDirection == "moon" ) then
			MoonTimeNextCastframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
		else
			MoonTimeNextCastframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
		end 
	end
	
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["glow"] then
		if ( isSolar or isLunar ) then
			ActionButton_ShowOverlayGlow(MoonTimeNextCastframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeNextCastframe:GetGlowFrame());
		end 
	end
	MoonTimeNextCastframe:SetTextHeight(20)

	MoonTimeNextCastframe:SetBackdropColor(1,1,1,alpha)
	MoonTimeNextCastframe:SetHeight(ydim)
	MoonTimeNextCastframe:SetWidth(xdim)
	


	
	alpha = 1;
else
	MoonTimeNextCastframe:Hide()
end

-- MoonTimeEclipseframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["active"] ) then
	if ( eclipseDirection == "moon" ) then
		MoonTimeEclipseframe:SetIcon(Solar_icon)
	else
		MoonTimeEclipseframe:SetIcon(Lunar_icon)
	end
	MoonTimeEclipseframe:Show()
	
	if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["appearance"] == "text" ) then
	
		if eclipseDirection == "sun" then
			MoonTimeEclipseframe:SetText( "|cff0088ff".. abs(eclipsePower) .."|r" )
		elseif eclipseDirection == "moon" then
			MoonTimeEclipseframe:SetText( "|cffffff00".. abs(eclipsePower) .."|r" )
		else
			MoonTimeEclipseframe:SetText( "|cffffffff".. abs(eclipsePower) .."|r" )
		end
		MoonTimeEclipseframe:SetTextHeight(7)
		if eclipseDirection == "moon" and eclipsePower>0 then
			MoonTimeEclipseframe:SetTextHeight(10)
			MoonTimeEclipseframe:SetBackdropColor(1,1,1,1)
		elseif eclipseDirection == "sun" and eclipsePower<0 then
			MoonTimeEclipseframe:SetTextHeight(10)
			MoonTimeEclipseframe:SetBackdropColor(1,1,1,1)
		end
		
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["glow"] then
		if ( isSolar or isLunar ) then
			ActionButton_ShowOverlayGlow(MoonTimeEclipseframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeEclipseframe:GetGlowFrame());
		end 
	end
else
	MoonTimeEclipseframe:Hide()
end

-- MoonTimeMFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["active"] ) then
	MoonTimeMFframe:SetText( '' )
	MoonTimeMFframe:Show()
	
	if ( MF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "text" then
			MoonTimeMFframe:SetText( '|cfff6ffff' .. math.ceil(MF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["appearance"] == "popup" then
			MoonTimeMFframe:Hide()
		else
			MoonTimeMFframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["glow"] then
		if ( MF_CD <= 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeMFframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeMFframe:GetGlowFrame());
		end 
	end
else
	MoonTimeMFframe:Hide()
end	

-- MoonTimeSunFframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["active"] ) then
	MoonTimeSunFframe:SetText( '' )
	MoonTimeSunFframe:Show()
	
	if ( SunF_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "text" then
			MoonTimeSunFframe:SetText( '|cfff6ffff' .. math.ceil(SunF_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["appearance"] == "popup" then
			MoonTimeSunFframe:Hide()
		else
			MoonTimeSunFframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["glow"] then
		if ( SunF_CD <= 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeSunFframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeSunFframe:GetGlowFrame());
		end 
	end
else
	MoonTimeSunFframe:Hide()
end	

-- MoonTimeStarrainframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["active"] ) then

	MoonTimeStarrainframe:SetText( '' )
	MoonTimeStarrainframe:Show()
	
	if ( SR_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["appearance"] == "text" then
			MoonTimeStarrainframe:SetText( '|cfff6ffff' .. math.ceil(SR_CD) .. '|r' )
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["appearance"] == "popup" then
			MoonTimeStarrainframe:Hide()
		else
			MoonTimeStarrainframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["glow"] then
		if ( SR_CD == 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeStarrainframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeStarrainframe:GetGlowFrame());
		end 
	end
else
	MoonTimeStarrainframe:Hide()
end
		
-- MoonTimeFaerieFireframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["active"] ) then

	MoonTimeFaerieFireframe:SetText( '' )
	MoonTimeFaerieFireframe:Show()
	
	if ( FF_CD > 1.5 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "text" then
			if FF_CD > 99 then
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD/60) .. 'm|r' )
			else
				MoonTimeFaerieFireframe:SetText( '|cfff6ffff' .. math.ceil(FF_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["appearance"] == "popup" then
			MoonTimeFaerieFireframe:Hide()
		else
			MoonTimeFaerieFireframe:SetText( ' ' )
		end
	end
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["glow"] then
		if ( FF_CD < 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeFaerieFireframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeFaerieFireframe:GetGlowFrame());
		end 
	end
else
	MoonTimeFaerieFireframe:Hide()
end

-- MoonTimeCelestialAlignmentframe
if ( MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["active"] ) then

	MoonTimeCelestialAlignmentframe:SetText( '' )
	MoonTimeCelestialAlignmentframe:Show()
	
	
	if ( CA_CD > 0 ) then
		if MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "text" then
			if CA_CD > 175 then
				MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.0f',CA_CD-165) .. '|r' )
			elseif CA_CD > 165 then
				MoonTimeCelestialAlignmentframe:SetText( '|cffffff00' .. string.format('%2.1f',CA_CD-165) .. '|r' )
			elseif CA_CD > 99 then
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD/60) .. 'm|r' )
			elseif CA_CD < 10 then
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. string.format('%2.1f',CA_CD) .. '|r' )
			else
				MoonTimeCelestialAlignmentframe:SetText( '|cfff6ffff' .. math.ceil(CA_CD) .. '|r' )
			end
		elseif MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["appearance"] == "popup" then
			MoonTimeCelestialAlignmentframe:Hide()
		else
			MoonTimeCelestialAlignmentframe:SetText( ' ' )
		end
	end
	
	if MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["glow"] then
		if ( CA_CD < 0 ) then
			ActionButton_ShowOverlayGlow(MoonTimeCelestialAlignmentframe:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(MoonTimeCelestialAlignmentframe:GetGlowFrame());
		end 
	end
else
	MoonTimeCelestialAlignmentframe:Hide()
end
	

-- TierFrames	
	
for a = 1, 18, 1 do

	local name, texture, tier, column, selected, available = GetTalentInfo(a)	
	local charges, maxCharges, start, duration = GetSpellCharges(name)
	
	local talentduration = 0;
	
	if a == 11 then
		talentduration = 30;
	end
	
	if ( selected and MoonTime_DB["Layout_noBrainShift"][name]["active"] ) then
		local CD, duration = cds:GetTalentCD(a)

		TierListe[name]:SetText( '' )
		TierListe[name]:Show()
	
--[[		if not charges then
			charges = 0
		end--]]
	
		TierListe[name]:SetChargesText( '' )
	
		if charges then
		
			if charges < maxCharges then
				TierListe[name]:SetChargesText( math.ceil(start+duration-GetTime()) )
			end
		
			if (charges == 0 or procs < 2) and charges < maxCharges  then
				TierListe[name]:SetText( ' ' )
				TierListe[name]:SetBackdropColor(1,1,1,.1)
			else
				TierListe[name]:SetText( charges )
				TierListe[name]:SetBackdropColor(1,1,1,1)	
			end
					
		else
			
			if ( CD > 0 ) then
				if MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "text" then
					if talentduration > 0 and CD > duration-talentduration and CD-duration+talentduration < 10 then
						TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.1f',CD-duration+talentduration) .. '|r' )
					elseif CD > duration - talentduration then
						TierListe[name]:SetText( '|cfff6ff00' .. string.format('%2.0f',CD-duration+talentduration) .. '|r' )
					elseif CD > 99 then
						TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD/60) .. 'm|r' )
					else
						TierListe[name]:SetText( '|cfff6ffff' .. math.ceil(CD) .. '|r' )
					end
				elseif MoonTime_DB["Layout_noBrainShift"][name]["appearance"] == "popup" then
					TierListe[name]:Hide()
				else
					TierListe[name]:SetText( ' ' )
				end
			end
		
		end
		
	if MoonTime_DB["Layout_noBrainShift"][name]["glow"] then
		if ( CD == 0 ) then
			ActionButton_ShowOverlayGlow(TierListe[name]:GetGlowFrame());
		else
			ActionButton_HideOverlayGlow(TierListe[name]:GetGlowFrame());
		end 
	end
		
		
		
	else
		TierListe[name]:Hide()
	end
end



end	
	
	
	
	
	
	
	
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, width, height, relwhich, relto, xoff, yoff )
		if not xoff then xoff= 0 end
		if not yoff then yoff= 0 end

		
		
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetBackdrop({
			bgFile = spellTexture,
			tile = false, tileSize = height, edgeSize = 0,
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		})
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, xoff, yoff)
		
		local glowframe = CreateFrame( "Frame", "MTGlowframe", frame )
		glowframe:SetHeight(height+8)
		glowframe:SetWidth(width+8)
		glowframe:SetPoint("CENTER", frame, "CENTER", 0, 0)
		
		frame.GetGlowFrame = function ( self )
			return glowframe
		end

		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		--labelframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		--labelframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
		--labelframe:SetPoint("TOPLEFT", frame, "TOPLEFT",0,0)
		--labelframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)
		--labelframe:SetHeight(height-2)
		--labelframe:SetWidth(width-2)
		labelframe:SetTextColor( 1, 1, 1, 1 );

		
		
		-- find the right textheight
		local h = 50;
		labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
		labelframe:SetText('10m');
			while labelframe:GetStringWidth()-2 > frame:GetWidth() and h>1 do
				h = h-1;
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")	
			end	
		labelframe:SetText('');
		--labelframe:SetHeight(height)
		--labelframe:SetWidth(width)
		labelframe:SetJustifyH("CENTER")
		labelframe:SetJustifyV("MIDDLE")

		
		frame.SetText = function( self, msg )
			if( msg == '' ) then
				frame:SetBackdropColor(1,1,1,1)		
			else
				frame:SetBackdropColor(1,1,1,.5)	
			end
			labelframe:SetText(msg)
			--labelframe:SetWidth(labelframe:GetStringWidth())
			labelframe:SetPoint("CENTER", frame, "CENTER")
			
			--print(labelframe:GetLeft())
			
		end
		
		local chargesframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		chargesframe:SetPoint("TOPLEFT", frame, "TOPLEFT")
		chargesframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)
		chargesframe:SetTextColor( .8, .8, .8, 1 );
		--chargesframe:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
		chargesframe:SetJustifyH("RIGHT")
		chargesframe:SetJustifyV("BOTTOM")
		
		-- find the right textheight
		local h = 8;
		chargesframe:SetFont("Fonts\\FRIZQT__.TTF", h, "OUTLINE")
		chargesframe:SetText('0m');
			while chargesframe:GetStringWidth() > frame:GetWidth()/2 and h>1 do
				h = h-1;
				chargesframe:SetFont("Fonts\\FRIZQT__.TTF", h, "OUTLINE")		
			end			
		chargesframe:SetText('');
		
		
		frame.SetChargesText = function( self, msg )
			chargesframe:SetText(msg)
		end
		
		
		frame.SetTextHeight = function( self, height )
			labelframe:SetFont("Fonts\\FRIZQT__.TTF", height, "OUTLINE")
			
	
			while height>0 and labelframe:GetStringWidth() > labelframe:GetWidth() do
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", height, "OUTLINE")
				height= height-1;
			end
		end
		
		frame.SetJustifyH = function( self, H )
			labelframe:SetJustifyH(H);
		end
		
		frame.SetJustifyV = function( self, V )
			labelframe:SetJustifyV(V);
		end			

		frame.SetIcon = function( self, icon )
			frame:SetBackdrop({bgFile = icon})
		end
		
		return frame
	end

	layerFrame.createLayout = function ()
		MoonTimeMFframe = layerFrame.CreateCastFrame( MF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeMFframe"]["yoffset"])
		MoonTimeSunFframe = layerFrame.CreateCastFrame( SunF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeSunFframe"]["yoffset"])
		MoonTimeStarrainframe = layerFrame.CreateCastFrame( SR_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeStarrainframe"]["yoffset"])
		MoonTimeFaerieFireframe = layerFrame.CreateCastFrame( FF_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeFaerieFireframe"]["yoffset"])
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeEclipseframe"]["yoffset"])
		MoonTimeNextCastframe = layerFrame.CreateCastFrame( "", layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeNextCastframe"]["yoffset"])
		MoonTimeCelestialAlignmentframe = layerFrame.CreateCastFrame( CA_icon, layerFrame, MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xdim"], MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["xoffset"],MoonTime_DB["Layout_noBrainShift"]["MoonTimeCelestialAlignmentframe"]["yoffset"])
		
		for a = 1, 18, 1 do
			local name, texture = GetTalentInfo(a, 1, nil, nil, 11)	
--print(name)			
			TierListe[name] = layerFrame.CreateCastFrame( texture, layerFrame, MoonTime_DB["Layout_noBrainShift"][name]["xdim"], MoonTime_DB["Layout_noBrainShift"][name]["ydim"], "CENTER", "CENTER",MoonTime_DB["Layout_noBrainShift"][name]["xoffset"],MoonTime_DB["Layout_noBrainShift"][name]["yoffset"])
		end
end	

	layerFrame.deleteLayout = function()
		MoonTimeNextCastframe:Hide()
		MoonTimeNextCastframe = nil
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMFframe:Hide()
		MoonTimeMFframe = nil
		MoonTimeSunFframe:Hide()
		MoonTimeSunFframe = nil
		MoonTimeStarrainframe:Hide()
		MoonTimeStarrainframe = nil
		MoonTimeFaerieFireframe:Hide()
		MoonTimeFaerieFireframe = nil
		MoonTimeCelestialAlignmentframe:Hide()
		MoonTimeCelestialAlignmentframe = nil
for a = 1, 18, 1 do

	local name, texture = GetTalentInfo(a, 1, nil, nil, 11)		
	TierListe[name]:Hide()
	TierListe[name] = nil
	
end
		
		layerFrame:Hide()
		layerFrame = nil
	end
	


	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIPARENT	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	
	
	

	--frame:SetScript("OnUpdate", function(self, event, ... ) OnUpdate(event, ...) end)
	
	
	frame:SetScript("OnEvent", 
		function( self, event )
		
			if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
																		-- werden die ausstehenden Events registriert
				if ( GetLocale() == "deDE" ) then
					frame.description = MoonTime_noBrainShift_Strings["deDE"]["description"]
				else
					frame.description = MoonTime_noBrainShift_Strings["enGB"]["description"]
				end
				
				frame:SetScript("OnUpdate", function(self, event, ... ) 		
					name = GetTalentInfo(18, 1, nil, nil, 11);
		
				if name then
					frame:SetScript("OnUpdate",nil)
					MoonTimeDoorKeeper:RegisterLayout( self );
				end 
		
			end)
		end
	end)
				
	--[[			
				--MoonTimeDoorKeeper:RegisterLayout( self );
			print("variablen geladen")
			end
			if event=="INSPECT_READY" then
				print("talente sollten da sein")
				
				for a = 18, 18, 1 do
					local name, texture = GetTalentInfo(a, 1, nil, nil, 11)	
					print(name)			
				end
				MoonTimeDoorKeeper:RegisterLayout( self );
			end

	
		end
	)
	

	--]]
	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end

	frame.Hide = function()
		--print("hide()")
		LayoutFrame:Hide()
	end
	frame.Show = function()
		--print("show()")
		LayoutFrame:Show()
	end
	frame.Update = function()
		LayoutFrame:Update()
	end

	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
	

	
end																		-- Ende initialize

registerLayout(NameOfLayout)